
#property copyright "Martin Lemire, phover "
#property link      "mlemire12@videotron.ca "

#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 0.2
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Crimson

extern int ADX_period = 20;
extern int MOM_period = 20;
extern int MACD_fast_ema = 5;
extern int MACD_slow_ema = 15;
extern int MACD_signal_period = 9;
extern int MaxBarsOnGraph = 500;
double Up_Sig[];
double Dn_Sig[];
double ADXWeih[];
double ADXWeig[];
double MomWeiU[];
double MomWeiD[];
double MCDWeiU[];
double MCDWeiD[];
double ADX_PlusDi;
double ADX_MinuDi;
double ADX_MainDi;
double Momentum_i;
double MACD_Maini;
int NrOfBars;
int Limit;
int i;
int ADX_Fl;
int Mom_Fl;
int MCD_Fl;
int Sig_Fl;
int CurADX;
int CurMom;
int CurMCD;

int counted_bars;
int WinFin;

string ShName = "TheSecret Trend Reversal";


int init() {
   IndicatorShortName(ShName);
   SetIndexStyle(0, DRAW_ARROW, STYLE_SOLID, 0);
   SetIndexArrow(0, 108);
   SetIndexBuffer(0, Up_Sig);
   SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID, 0);
   SetIndexArrow(1, 108);
   SetIndexBuffer(1, Dn_Sig);
   SetIndexEmptyValue(0, 0);
   SetIndexEmptyValue(1, 0);
   CurADX = 0;
   CurMom = 0;
   CurMCD = 0;
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   WinFin = WindowFind(ShName);
   if (NrOfBars != Bars) NewBar();
   if (counted_bars > 0) counted_bars--;
   Limit = NrOfBars - counted_bars - 1;
   if (Limit > MaxBarsOnGraph) Limit = MaxBarsOnGraph;
   for (i = Limit - 1; i >= 0; i--) {
      ADX_PlusDi = iADX(NULL, 0, ADX_period, PRICE_CLOSE, MODE_PLUSDI, i);
      ADX_MinuDi = iADX(NULL, 0, ADX_period, PRICE_CLOSE, MODE_MINUSDI, i);
      ADX_MainDi = iADX(NULL, 0, ADX_period, PRICE_CLOSE, MODE_MAIN, i);
      Momentum_i = iMomentum(NULL, 0, MOM_period, PRICE_CLOSE, i);
      MACD_Maini = iMACD(NULL, 0, MACD_fast_ema, MACD_slow_ema, MACD_signal_period, PRICE_CLOSE, MODE_MAIN, i);
      if (ADX_PlusDi >= ADX_MinuDi) {
         ADXWeih[i] = 0.1;
         if (ADX_Fl == -1 || ADX_Fl == 0) {
            ADX_Fl = 1;
            CurADX = TimeCurrent();
         }
      }
      if (ADX_PlusDi < ADX_MinuDi) {
         ADXWeig[i] = 0.1;
         if (ADX_Fl == 1 || ADX_Fl == 0) {
            ADX_Fl = -1;
            CurADX = TimeCurrent();
         }
      }
      if (Momentum_i >= 100.0) {
         MomWeiU[i] = 0.3;
         if (Mom_Fl == -1 || Mom_Fl == 0) {
            Mom_Fl = 1;
            CurMom = TimeCurrent();
         }
      }
      if (Momentum_i < 100.0) {
         MomWeiD[i] = 0.3;
         if (Mom_Fl == 1 || Mom_Fl == 0) {
            Mom_Fl = -1;
            CurMom = TimeCurrent();
         }
      }
      if (MACD_Maini >= 0.0) {
         MCDWeiU[i] = 0.5;
         if (MCD_Fl == -1 || MCD_Fl == 0) {
            MCD_Fl = 1;
            CurMCD = TimeCurrent();
         }
      }
      if (MACD_Maini < 0.0) {
         MCDWeiD[i] = 0.5;
         if (MCD_Fl == 1 || MCD_Fl == 0) {
            MCD_Fl = -1;
            CurMCD = TimeCurrent();
         }
      }
      if (ADX_Fl == 1  && Mom_Fl == 1  && MCD_Fl == 1)  Sig_Fl = 1;
      if (ADX_Fl == -1 && Mom_Fl == -1 && MCD_Fl == -1) Sig_Fl = -1;
      if (Sig_Fl == 1) Up_Sig[i] = 0.08;
      else Dn_Sig[i] = 0.08;
   }
   WindowRedraw();
   return (0);
}

void NewBar() {
   NrOfBars = Bars;
   counted_bars++;
}
